<?php 
global $filename;

// Zuerst definieren wir die Funktionen, die spter auf
// die diversen Ereignisse reagieren sollen
/**
 * Diese Funktion behandelt ein ffnendes Element.
 * Alle Parameter werden automatisch vom Parser bergeben
 *
 * @param    parser    Object    Parserobjekt
 * @param    name      string    Name des ffnenden Elements
 * @param    atts      array     Array mit Attributen
 */
function startElement($parser, $name, $atts) {
  global $html, $competition, $ID, $game_id, $round, $value;

  // Die XML-Namen werden in Grobuchstaben bergeben.
  // Deshalb wandeln wir sie mit strtolower() in Klein-
  // buchstaben um.
  switch (strtolower($name)) {
  case "competition";
	$value = 'competition';
    break;
  case "options";
	$value = 'options';
    break;
  case "name";
	$value = 'name';
    break;
  case "rounds";
	$value = 'rounds';
    break;
  case "round_names";
	$value = 'round_names';
    break;
  case "teams";
	$value = 'teams';
    break;
  case "team";
	$value = 'team';
    $ID = $atts["ID"];
    break;
  case "team_name";
	$value = 'team_name';
    break;
  case "team_shortname";
	$value = 'team_shortname';
    break;

  case "games";
	$value = 'games';
    break;
  case "round";
	$value = 'round';
    $round = $atts["NUMBER"];
    break;
  case "game";
	$value = 'game';
	$game_id = $atts["ID"];
    break;
  case "gametime";
	$value = 'gametime';
    break;
  case "team1";
	$value = 'team1';
    break;
  case "team2";
	$value = 'team2';
    break;    
        
  default:
    // Ein ungltiges Element ist vorgekommen.
    $error = "Undefiniertes Element <".$name.">";
    die($error . " in Zeile " . 
        xml_get_current_line_number($parser));
    break;
  }
}
/**
 * Diese Funktion behandelt ein abschlieendes Element
 * Alle Parameter werden automatisch vom Parser bergeben
 *
 * @param  parser    Object    Parserobjekt
 * @param  name      string    Name des schlieenden Elements
 */
function endElement($parser, $name) {
  global $html;
  switch (strtolower($name)) {
  case "ref":
    $html .= "</a>";
    break;
  }
}

/**
 * Diese Funktion behandelt normalen Text
 * Alle Parameter werden automatisch vom Parser bergeben
 *
 * @param    parser    Object    Parserobjekt
 * @param    text      string    Der Text
 */
function cdata($parser, $text) {
  global $competition, $ID, $game_id, $value, $options_new, $teams, $round, $games;
	
	/* get the options */
	if ($value == "name" AND $text){
		$options_new['name'] .= $text;
		}
	if ($value == "rounds" AND $text){
		$options_new['rounds'] .= $text;
		}
	if ($value == "round_names" AND $text){
		$options_new['round_names'] .= $text;
		}

	/* get the teams */
	if ($value== "team_shortname" AND $text) {
		$teams[$ID]->team_shortname .= $text;
		}
	if ($value== "team_name" AND $text) {
		$teams[$ID]->team_name .= $text;
		}

	/* get the games */
	if ($value== "gametime" AND $text > 0) {
		$games[$game_id]->gametime .= $text;
		$games[$game_id]->round .= $round;
		}
	if ($value== "team1" AND $text > 0) {
		$games[$game_id]->team1 .= $text;
		}
	if ($value== "team2" AND $text > 0) {
		$games[$game_id]->team2 .= $text;
		}
}

global $wpdb, $ID, $options_new, $teams, $value, $games;
$xmlFile = implode("", file($filename));


$parser = xml_parser_create();
// Setzen der Handler
xml_set_element_handler($parser,"startElement","endElement");
// Setzen des CDATA-Handlers
xml_set_character_data_handler($parser, "cdata");
// Parsen
xml_parse($parser, $xmlFile);
// Gibt alle verbrauchten Ressourcen wieder frei.
xml_parser_free($parser);

/* write the new competiton */
$form->name = $options_new['name'];
$form->rounds = $options_new['rounds'];
$form->round_names = trim($options_new['round_names']);
/* get the new competition_id and save */
$competition_id = pl_save_competition($form);


/* write the teams */
/* get the new team ids */
foreach ($teams as $key => $team){
	$team->competition_id = $competition_id;
	$new_teams[$key]->team_id = pl_save_team($team);
	$new_teams[$key]->team_name = $team->team_name;
}

/* convert the old team ids to new team ids */
/* write the games */
foreach ($games as $game){
		/* using the old ids to get the new team_ids for the game */
		unset($form);
		$form->gametime = $game->gametime;
		$form->team1 = $new_teams[$game->team1]->team_id;
		$form->team2 = $new_teams[$game->team2]->team_id;
		$form->round = $game->round;
		$form->competition_id = $competition_id;
		pl_save_game($form);
	
}

/* ready */
?>